<?php
	/*
    File: globsy_action_func.php
    Author: mEo
    Date: September 28th 2006
    Version: 1.0.0
    
                      INFORMATION
    ---------------------------------------------
    This file provides a number of Jabber / 
    Google Talk related functions, such as
    SendMsg.  It can be used in
    globsy_action.php's MainLoop() and all of the
    events in globsy_event.php.  It is highly
    recommended that you do not edit this file.
    ---------------------------------------------
     
                      CONTENTS
    ---------------------------------------------
     - Special Globsy Functions:
       These functions can be used for Jabber
       related tasks, such as sending messages,
       adding / removing users etc.
    ---------------------------------------------
    
   
    ***Available Action Functions:
     - Stop()
     - StopNow()
     - Restart()
     - IsAdmin($email)
     - SendMsg($to, $body)
     - GetRoster()
     - SendStatus()
     - SendStatus($status, $extrastatus)
     - AddUser($jid, $id, $name)
     - RemoveUser($jid, $id)

    ***Available Objects:
     - $Roster       - Roster / Contact List.  Also contained in $JClient.
     - $JClient      - the class.jabber.php object
     - $conf         - array of the contents of the config file
    
	Note:  To use these objects, make a global
           variable.
           eg. global $Roster;
    
    */

    /***********************************************
                  Don't edit the following
    ***********************************************/
    
    function Stop() {
        //Stops the bot on the next refresh
        
        global $JClient;
        $JClient->end=TRUE;
    }
    
    function StopNow() {
        //Stops the bot immediately
       
        die("The bot has been forcably ended.");
    }
   
    function Restart() {
        //Restarts the bot, using globsy_start.php;
		global $JClient;
		$JClient->Disconnect();
        exec("php globsy_start.php");
        die("Bot restarting...");
    } 
    
    function IsAdmin($email) {
        //Checks to see if the given email is in the admin list.
        // $email: Email to check for admin status on.
        //
        //Note:  The admin list is contained in the config file (globsy_config.php)
        
        global $conf;
        $admins=$conf['admins'];
        if(strpos($admins,$email.",")===FALSE) {
            return FALSE;
        } else {
            return TRUE;
        }
    }
   
    // Jabber functions
   
    function SendMsg($to, $body) {
        // Sends a message to $to
        // $to: Receipiant
        // $body: Message
        // eg. SendMsg("globsy@gmail.com, "Heya!");
        
        global $JClient;
        $JClient->SendMessage($to, 'chat', NULL, array("body" => $body));

    }
    
    function GetRoster() {
        // Updates the roster (contact list)
        // and sets $cl to the current contact
        // list.
        
        global $JClient;
        $JClient->RosterUpdate();
        global $Roster;
        $Roster=$JClient->roster;
    }    
    
    function SendStatus($status,$extrastatus) {
        // Sends your status to all those on
        // the contact list.
        // $status: main state (eg. unavailable, available, na)
        // $extrastatus: extra string of text; can be more detailed.
        //               eg. "Out to Lunch"
        
        global $JClient;       
        $JClient->SendPresence(NULL, NULL, $extrastatus, $status);
    }
    
    // For the following, $jid, $id and $name can be
    // retreived from the $roster (array) varilable
    
    //***
    
    function AddUser($jid, $id, $name) {
        // Adds a user to the roster
        // $jid: Email of user to add.
        // $id:  If unsure, leave blank.
        // $name: Name of the user (ie. Screenname, of sorts)
        
        global $JClient;        
        $JClient->RosterAddUser($jid, $id, $name);
    }
    
    function RemoveUser($jid, $id) {
        // Removes a user from the roster
        // $jid: Email of user to remove.  Can be retrieved from the Roster Object.
        // $id: Retrieve from the roster object.
        
        global $JClient;        
        $JClient->RosterRemoveUser($jid, $id);
    }
    
?>
