<?php
	/*
    File: globsy_event.php
    Author: mEo
    Date: September 28th 2006
    Version: 1.0.0
    
                      INFORMATION
    ---------------------------------------------
    Various functions in this file are executed
    whenever a certain event occurs, such as a
    message being received, or a user's presence
    being sent.  Adding your own code to these
    events allows you to perform actions whenever
    that event occurs.  In addition to all PHP
    code, obviously, you also have the functions
    listed in globsy_action_func.php.  They are
    also listed below.
    ---------------------------------------------
     
                      CONTENTS
    ---------------------------------------------
     - Standard Event Functions:
       Raised whenever a certain event occurs
    ---------------------------------------------
    
   
    ***Available Action Functions:
     - Stop()
     - StopNow()
     - Restart()
     - IsAdmin($email)
     - SendMsg($to, $body)
     - GetRoster()
     - SendStatus()
     - SendStatus($status, $extrastatus)
     - AddUser($jid, $id, $name)
     - RemoveUser($jid, $id)

    ***Available Objects:
     - $Roster       - Roster / Contact List.  Also contained in $JClient.
     - $JClient      - the class.jabber.php object
     - $conf         - array of the contents of the config file
    
    Note:  To use these objects, make a global
           variable.
           eg. global $Roster;
    */
    
    //***********************************************
    //     Standard Event Functions - Edit These
    //***********************************************   
     
    function recv_message($from, $body) {
        // Return a string to send back to $from, blank to send nothing
        //
        // Note:  If you return a value, the function will not continue.
        //   eg.  The following will NOT work:
        //        return "Bot Stopping";
        //        StopNow();
        
        // These are where your admin commands should go.
        // The function IsAdmin() checks to see if the email given is
        // in fact an admin (listed in globsy_config.php).

        if(IsAdmin($from)) {
            if($body=="!restart") {
                SendMsg($from, "Please wait while the bot restarts...");
                Restart();
            } elseif($body=="!end") {
                //This will end the bot.
                
                SendMsg($from, "Please wait while the bot closes...");
                StopNow();
            }
        }
        
        // Non-admin related functions.  You can add a } else { here, 
        // but adding one in the admin section would result in the following
        // not being available (as the function would quit before this point
        // was reached).

		// Just a quick example of how you can use sent text not in the form
		// of a command (see further below).
        if($body=="hello") {
            return "Hello to you to ".$from."!";
        }

		// The following code allows for commands in the format of:
		// 	!command parameters
		//
		// If you wish to edit it, you can, but it is in a working condition.
		// Other commands can be added in the switch($command)

        $char = substr($body, 0, 1);
		if($char=="!") { 
	    	$pos=strpos($body, " ");
		    if($pos>0) {
		        $command=substr($body, 0, $pos);
		        if($command!="") {
		            $params=substr($body, $pos+1);
		        }
		    } else {
		        $command=$body;
			}
        }

        switch($command) {
            case "!hello":
				return "Hello to you too!";
				// No need for break, because return has been used.
            case "!hello2":
				// The following can be done using return, however as an
				// example, the SendMsg() function has been used.

				SendMsg($from, "Hello to you too ".$from."!");
				break;
			case "!help":
				// Sends available commands (needs to be manually updated)

				return "\nAvailable Commands Are:\n\t".
					   "\t!hello\n".
					   "\t!hello2\n".
					   "\t!help";
            default:
				// An unknown command.
                return "Unknown command: ".$command."\nType !help for a list of commands.";
        }
    }
    
    function presence($from,$status, $show_status,$available) {
        // $available is a boolean.  TRUE is available / online,
        //                           FALSE is unavailable / offline
        // 
        // Note: $status and $show_status may not return any value.
        //       Try using the roster object instead.
    }
    
    function presence_subscribe($from) {
        //Return TRUE to accept, FALSE to decline
        
        return TRUE;
    }
    
    function presence_subscribed($from) {
        
    }
    
    function presence_unsubscribe($from) {
        //Return TRUE to allow unsubscription, FALSE to decline
        
        return TRUE;
    }
?>
